import sys, time, pygame, random, math, copy, os
from pygame.locals import *

import myDataloader, myFrames, myObjects, myLevels
import PW15_objects as customObjects
import PW15_variables as customVariables
from myConstants import *


	
		
#class Ade(myLevels.LevelWithFullRefresh):	
class Ade(myLevels.LevelWithLayeredUpdates):
	def __init__(self, currentLevel, screenSize, debugOn, musicOn, inventory, sortedLayers):
		#myLevels.LevelWithFullRefresh.__init__(self, currentLevel, screenSize, debugOn, musicOn, inventory)	
		myLevels.LevelWithLayeredUpdates.__init__(self, currentLevel, screenSize, debugOn, musicOn, inventory, sortedLayers)	
		self.loadMap()
		self.backgroundImage=pygame.Surface(screenSize,pygame.SRCALPHA, 32).convert_alpha()
		self.backgroundImage.fill(pygame.Color('Black'))
		self.pauseScreen=None
		self.resultScreen=None
		self.loseScreen=None
		self.helpScreen=None
		
		self.leftOarPressed=False
		self.rightOarPressed=False
		
		self.clock=0
		self.speed=4*FPS
		
		self.riverSpeed=0.0
		self.riverDirection=0
		
		self.charon=None
		self.souls=[]
		self.numOfCollectedCoins=0
		self.inventory['level'][self.currentLevel]['gold']=self.numOfCollectedCoins		
		for soulName in customVariables.LIST_OF_SOULS[:min(len(customVariables.LIST_OF_SOULS),(self.currentLevel-1)/5+1)]:
			self.inventory['level'][self.currentLevel]['soul'][soulName][True]=0
			self.inventory['level'][self.currentLevel]['soul'][soulName][False]=0
		if 'obj_damned.png' in self.inventory['level'][self.currentLevel]['soul'].keys():
			self.inventory['level'][self.currentLevel]['soul']['obj_damned.png'][False]=0
		
	def loadMap(self):
		filename='level'+str(self.currentLevel).rjust(2,'0')+'.map'
		f = myDataloader.load_level(filename)
		self.map = f.readlines()
		f.close()
		checkMap=''.join(self.map)
		if 'C' not in checkMap: print 'MAP CHECK ERROR: missing Charon'
		if 'S' not in checkMap: print 'MAP CHECK ERROR: missing Start'
		if 'F' not in checkMap: print 'MAP CHECK ERROR: missing Finish'
			
	
	def generateMap(self):
		self.riverCellSize=[self.screenSize[0]/16,self.screenSize[1]/12]
		self.riverBigObjectsSize=[self.riverCellSize[0]*30/25,self.riverCellSize[1]*30/25]
		self.riverDockSize=[self.riverCellSize[0],self.riverCellSize[1]*40/25]
		self.riverBorders=[[self.riverCellSize[0]/4,self.riverCellSize[1]],[self.riverCellSize[0]/4+self.riverCellSize[1]*10,self.riverCellSize[1]*11]]
		self.riverAreaSize=[10,10]
		
		self.ferryBorders=[[self.riverCellSize[0]*15/50+self.riverCellSize[0]*10,self.riverCellSize[1]*3/2],[self.riverCellSize[0]*35/50+self.riverCellSize[1]*15,self.riverCellSize[1]*3/2+self.riverCellSize[1]*9]]
		
		#genrate river map
		self.isMap=True
		self.maxNumOfCoins=0
		self.numOfStartingDocks=0
		self.riverCells=[]
		riverLine=[]
		row=column=0
		for line in self.map:
			if self.isMap:
				for cell in line:
					if cell in ['\n','\r',os.linesep]:
						continue
					if cell=='#':
						self.isMap=False
						break
					cellPosition=self.riverBorders[0][0]+(column+0.5)*self.riverCellSize[0],self.riverBorders[0][1]+(row+0.5)*self.riverCellSize[1]
					if cell =='C':
						self.yourPosition=cellPosition
					if cell in ['R','U','L','D']:
						riverLine.append(self.addObject(customObjects.RiverCellFlow(myFrames.getImageFrames('obj_river_flow.png'),self.riverCellSize,cellPosition,customVariables.dirChartToInt.index(cell))))
					elif cell=='V':
						riverLine.append(self.addObject(customObjects.RiverCellVortex(myFrames.getImageFrames('obj_river_vortex.png'),self.riverBigObjectsSize,cellPosition)))
					elif cell=='X':
						riverLine.append(self.addObject(customObjects.RiverCellRock(myFrames.getImageFrames('obj_river_rock.png'),self.riverCellSize,cellPosition)))
					elif cell=='S':
						self.startDock=self.addObject(customObjects.RiverCellStartDock(myFrames.getImageFrames('obj_river_dock_start.png'),self.riverDockSize,[cellPosition[0],cellPosition[1]+self.riverCellSize[1]*10/25]))
						riverLine.append(self.startDock)
						self.numOfStartingDocks+=1
					elif cell=='F':	
						riverLine.append(self.addObject(customObjects.RiverCellFinishDock(myFrames.getImageFrames('obj_river_dock_finish.png'),self.riverDockSize,[cellPosition[0],cellPosition[1]-self.riverCellSize[1]*10/25])))
					elif cell=='G':	
						riverLine.append(self.addObject(customObjects.RiverCellGold(myFrames.getImageFrames('obj_river_gold.png'),self.riverBigObjectsSize,cellPosition)))
						self.maxNumOfCoins+=1
					elif cell=='A':	
						riverLine.append(self.addObject(customObjects.RiverCellDamned(myFrames.getImageFrames('obj_river_soul.png'),self.riverCellSize,cellPosition)))
					elif cell=='Q':	
						riverLine.append(self.addObject(customObjects.RiverCellQuestion(myFrames.getImageFrames('obj_river_question.png'),self.riverCellSize,cellPosition)))
						self.maxNumOfCoins+=1						
					else:
						pass
						#riverLine.append(self.addObject(customObjects.RiverCell(myFrames.getImageFrames('obj_river_cell.png'),self.riverCellSize,cellPosition)))
						riverLine.append(customObjects.RiverCellEmpty())
					column+=1
				self.riverCells.append(riverLine)
				row+=1
				riverLine=[]
				column=0
			else:
				self.withCoinSouls,self.withoutCoinSoul,self.minCoinsToWin=[int(x) for x in line.split(',')]
				self.inventory['level'][self.currentLevel]['max']=self.numOfStartingDocks*self.withCoinSouls*customVariables.SOUL_BONUS+self.maxNumOfCoins*customVariables.GOLD_BONUS
				self.inventory['level'][self.currentLevel]['need']=self.minCoinsToWin
				#print 'needed/available check:',str(self.inventory['level'][self.currentLevel]['need'])+'/'+str(self.inventory['level'][self.currentLevel]['max'])
		
		#generate ferry bridge
		self.bridge=self.addObject(customObjects.Bridge(myFrames.getImageFrames('obj_bridge.png'),[self.screenSize[0]/400.0*135,self.screenSize[1]],[self.screenSize[0]/800.0*665,self.screenSize[1]/2]))
		
		#generate you
		self.yourSize=self.riverCellSize[0]*7/5,self.riverCellSize[1]*7/5
		self.you=self.addObject(customObjects.You(myFrames.getImageFrames('obj_ferry.png'),self.yourSize,self.yourPosition,self.riverBorders))
		
		#generate mouse cursor
		#pygame.mouse.set_pos([self.ferryBorders[1][0]-self.ferryBorders[0][0],self.ferryBorders[1][1]-self.ferryBorders[0][1]])
		self.mouseOar=self.addObject(customObjects.MouseOar(myFrames.getImageFrames('obj_mouse_oar.png'),self.riverBigObjectsSize,pygame.mouse.get_pos()))
		
		#generate info text
		self.infoText=self.addObject(myObjects.GameText(' Level '+str(self.currentLevel)+' - Gold='+str(self.you.gold)+'/'+str(self.minCoinsToWin)+self.debugOn*('/'+str(self.inventory['level'][self.currentLevel]['max'])),25,(self.ferryBorders[0][0],0),pygame.Color('Purple')))
			
			
	def killSoul(self,soul):
		soul=self.delObject(soul,[self.souls])

	def checkKeyPressure(self,keyEvent):
		#on pause
		if self.pauseScreen<>None:
			if (keyEvent.type == KEYDOWN and keyEvent.key == K_ESCAPE):
				self.jumpToLevel(LEVELSELECT)
				return True
			elif (keyEvent.type == KEYDOWN or keyEvent.type == MOUSEBUTTONDOWN):
				if (keyEvent.type == KEYDOWN and keyEvent.key in customVariables.help_key):
					self.helpScreen=self.addObject(customObjects.PauseScreen(self.screenSize,self.currentLevel,'screen_help1.png'))
				self.delObject(self.pauseScreen)
				self.pauseScreen=None
				print 'Pause OFF'
		#on result
		elif self.resultScreen<>None:
			if (keyEvent.type == KEYDOWN and keyEvent.key == K_ESCAPE):
				self.jumpToLevel(LEVELSELECT)
				return True
			elif ((keyEvent.type == KEYDOWN and keyEvent.key == K_RETURN) or keyEvent.type == MOUSEBUTTONDOWN):
				self.delObject(self.resultScreen)
				self.resultScreen=None
				#nextLevel has already been calculated properly (same level or next level) in self.resultScreen.checkWinCondition()
				self.jumpToLevel(self.nextLevel)
		#on lose
		elif self.loseScreen<>None:
			if (keyEvent.type == KEYDOWN and keyEvent.key == K_ESCAPE):
				self.jumpToLevel(LEVELSELECT)
				return True
			elif (keyEvent.type == KEYDOWN or keyEvent.type == MOUSEBUTTONDOWN):
				self.delObject(self.loseScreen)
				self.loseScreen=None
				self.jumpToLevel(self.currentLevel)
		#on help
		elif self.helpScreen<>None:
			if (keyEvent.type == KEYDOWN and keyEvent.key == K_ESCAPE):
				self.jumpToLevel(LEVELSELECT)
				return True
			elif (keyEvent.type == KEYDOWN or keyEvent.type == MOUSEBUTTONDOWN):
				self.delObject(self.helpScreen)
				self.helpScreen=None
		#on game
		elif keyEvent.type == KEYDOWN:
			#cheat/debug begin
			if self.debugOn:
				if keyEvent.key == K_PAGEUP:
					self.jumpToLevel(self.currentLevel-1)
				if keyEvent.key == K_PAGEDOWN:
					self.jumpToLevel(self.currentLevel+1)
			#cheat/debug end
			
			if keyEvent.key == K_ESCAPE:
				self.pauseScreen=self.addObject(customObjects.PauseScreen(self.screenSize,self.currentLevel,'screen_pause1.png'))
				print 'Pause ON'
				return True
			#new movementes start
			elif keyEvent.key in customVariables.both_oars:
				self.you.row(0)
			elif keyEvent.key in customVariables.left_oar:
				self.you.row(1)
			elif keyEvent.key in customVariables.right_oar:
				self.you.row(-1)				
			#new movementes end
			elif keyEvent.key in customVariables.level_restart:
				self.jumpToLevel(self.currentLevel)
			elif keyEvent.key in customVariables.help_key:
				self.helpScreen=self.addObject(customObjects.PauseScreen(self.screenSize,self.currentLevel,'screen_help1.png'))

		elif keyEvent.type == MOUSEBUTTONDOWN and keyEvent.button == 1:
				self.mouseOar.setNextAnimation('click',-1,True)
				for s in self.souls:
					if self.mouseOar.click(s.collisionRect):
						s.hit=True
						break
		elif keyEvent.type == MOUSEBUTTONUP and keyEvent.button == 1:
			self.mouseOar.setNextAnimation('default',-1,True)
				
		return False		

	
	def addGold(self, gold):
		self.you.gold+=gold
		self.infoText.editText(' Level '+str(self.currentLevel)+' - Gold='+str(self.you.gold)+'/'+str(self.minCoinsToWin)+self.debugOn*('/'+str(self.inventory['level'][self.currentLevel]['max'])))
			

	def customUpdate(self):
		if self.pauseScreen==None and self.resultScreen==None and self.loseScreen==None:
			self.clock+=1
		
			#delete dead souls
			for s in self.souls:
				if s.hit and (s.rect.right<self.ferryBorders[0][0] or s.rect.left>self.ferryBorders[1][0] or s.rect.bottom<self.ferryBorders[0][1] or s.rect.top>self.ferryBorders[1][1]):
					self.killSoul(s)

			
			#river speed
			ferry_x=self.you.rect.centerx-self.riverBorders[0][0]
			ferry_y=self.you.rect.centery-self.riverBorders[0][1]
			x_col=(self.you.rect.centerx-self.riverBorders[0][0])/self.riverCellSize[0]
			y_row=(self.you.rect.centery-self.riverBorders[0][1])/self.riverCellSize[1]
			cellType=self.riverCells[y_row][x_col].type
			if cellType=='empty':
				self.you.inFlow=False
				self.bridge.resetPosition()
				self.you.lastRock=[-1,-1]
			else:
				if cellType=='flow':
					self.you.inFlow=True
					self.you.riverDirection=self.riverCells[y_row][x_col].direction
				else:
					self.you.inFlow=False
					if cellType=='gold':
						self.delObject(self.riverCells[y_row][x_col])
						self.riverCells[y_row][x_col]=customObjects.RiverCellEmpty()
						self.takeGold()
					elif cellType=='rock':
						#self.you.bounce()
						#vibrate ferry
						self.bridge.vibrate()
						if self.you.lastRock<>[y_row,x_col]:
							for n in range(int(math.ceil(len(self.souls)*0.2))):
								random.choice(self.souls).hit=True
								#self.delObject(self.souls.pop())
							self.you.lastRock=[y_row,x_col]
					elif cellType=='vortex':
						if not self.you.inVortex:
							self.speed=1
						self.you.inVortex=True
						if self.speed>0:
							self.speed+=1
						if self.speed>2*FPS:
							self.loseScreen=self.addObject(customObjects.LoseScreen(self.screenSize,self.currentLevel,'screen_gameover1.png'))
							self.speed=-1
					elif cellType=='startdock':
						self.loadSouls(self.riverCells[y_row][x_col])
					elif cellType=='finishdock':
						self.unloadSouls()
					elif cellType=='damned':
						self.delObject(self.riverCells[y_row][x_col])
						self.riverCells[y_row][x_col]=customObjects.RiverCellEmpty()
						self.takeDamned()
					elif cellType=='question':
						self.delObject(self.riverCells[y_row][x_col])
						self.riverCells[y_row][x_col]=customObjects.RiverCellEmpty()
						if random.random()<0.5:
							self.takeGold()
						else:
							self.takeDamned()
		else:
			self.you.speed=0
	
	def takeGold(self):
		self.addGold(customVariables.GOLD_BONUS)
		self.numOfCollectedCoins+=1
		self.inventory['level'][self.currentLevel]['gold']=self.numOfCollectedCoins	
	
	def takeDamned(self):
		self.SoulSize=self.riverCellSize[0],self.riverCellSize[1]
		for n in range(customVariables.NUM_OF_SOULS_IN_WATER):
			randomPosition=[random.randint(self.ferryBorders[0][0]+self.SoulSize[0],self.ferryBorders[1][0]-self.SoulSize[0]),random.randint(self.ferryBorders[0][1]+self.SoulSize[1],self.ferryBorders[1][1]-self.SoulSize[1])]
			self.souls.append(self.addObject(customObjects.Soul('obj_damned.png',self.SoulSize,randomPosition,self.ferryBorders,False)))
		
	def loadSouls(self, dock):
		if dock.waitingSouls==True:
			self.SoulSize=self.riverCellSize[0],self.riverCellSize[1]
			for k in range(self.withCoinSouls+self.withoutCoinSoul):
				randomPosition=[random.randint(self.ferryBorders[0][0]+self.SoulSize[0],self.ferryBorders[1][0]-self.SoulSize[0]),random.randint(self.ferryBorders[0][1]+self.SoulSize[1],self.ferryBorders[1][1]-self.SoulSize[1])]
				randomSoulName=random.choice(self.availableSoulNames)
				self.souls.append(self.addObject(customObjects.Soul(randomSoulName,self.SoulSize,randomPosition,self.ferryBorders,k<self.withCoinSouls)))	
			dock.setNextAnimation('empty',-1,True)
			dock.waitingSouls=False
		
	def unloadSouls(self):
		while len(self.souls)>0:
			soul=self.souls.pop()
			self.addSoulToInventory(soul.name,soul.hasCoin)
			if soul.hasCoin:
				self.addGold(customVariables.SOUL_BONUS)
			else:
				self.addGold(customVariables.SOUL_MALUS)
			self.delObject(soul)

		if self.resultScreen==None:
			goldNeed=self.inventory['level'][self.currentLevel]['need']
			goldBest=self.inventory['level'][self.currentLevel]['best']
			goldLast=self.inventory['level'][self.currentLevel]['gold']
			soulLast=self.inventory['level'][self.currentLevel]['soul']			
			self.resultScreen=self.addObject(customObjects.ResultScreen(self.screenSize, self.currentLevel, goldNeed, goldBest, goldLast, soulLast, 'screen_levels.png'))
			self.inventory['level'][self.currentLevel]['best'],self.nextLevel=self.resultScreen.checkWinCondition()
	
	def addSoulToInventory(self, name, hasCoin):
		if name in self.inventory['level'][self.currentLevel]['soul'].keys():
			self.inventory['level'][self.currentLevel]['soul'][name][hasCoin]+=1
		else:
			self.inventory['level'][self.currentLevel]['soul'][name]={}
			self.inventory['level'][self.currentLevel]['soul'][name][hasCoin]=1
			

		return False

		

class LevelOne(Ade):
	def __init__(self, currentLevel, screenSize, debugOn, musicOn, inventory, sortedLayers):
		Ade.__init__(self, currentLevel, screenSize, debugOn, musicOn, inventory, sortedLayers)
		print 'level '+str(currentLevel)
		self.setBackground('screen_level1.png')
		if self.currentLevel==1:
			self.helpScreen=self.addObject(customObjects.PauseScreen(self.screenSize, self.currentLevel,'screen_help1.png'))		
			#self.addSoulToInventory('obj_skeleton.png', True)
			#self.resultScreen=self.addObject(customObjects.ResultScreen(self.screenSize, self.currentLevel, 1, 1, 1, self.inventory['level'][self.currentLevel]['soul'], 'screen_levels.png'))
		self.generateMap()
		self.availableSoulNames=customVariables.LIST_OF_SOULS[:min(len(customVariables.LIST_OF_SOULS),(self.currentLevel-1)/5+1)]
		
class PW15LevelSelection(myLevels.LevelSelection):
	def __init__(self, currentLevel, screenSize, debugOn, musicOn, inventory):
		myLevels.LevelSelection.__init__(self, currentLevel, screenSize, debugOn, musicOn, inventory)
		self.mouseOar=self.addObject(customObjects.MouseOar(myFrames.getImageFrames('obj_mouse_oar.png'),[self.screenSize[0]/16,self.screenSize[1]/12],pygame.mouse.get_pos()))
		
		
		self.levelMiniatures=[]
		unlockedCount=0
		self.levels=inventory['level']
		maxCol=int(math.sqrt(len(self.levels)))+1
		row=col=0
		for lev in self.levels.keys():
			locked=(unlockedCount>=3)
			imageName='obj_lev_miniature.png'
			goldMax=self.inventory['level'][lev]['max']
			goldBest=self.inventory['level'][lev]['best']
			size=[self.screenSize[0]/12,self.screenSize[1]/9]
			gap=self.screenSize[1]/20
			newMiniature=customObjects.LevelMiniature(myFrames.getImageFrames(imageName),size,[(col+2)*(size[0]+gap),(row+1)*(size[1]+gap)],lev,goldMax,goldBest,locked)
			
			
			self.levelMiniatures.append(self.addObject(newMiniature))
			if not newMiniature.locked and not newMiniature.completed:
				unlockedCount+=1
			row+=(col+1)/maxCol
			col=(col+1)%maxCol	

			

class Title(myLevels.Title):
	def __init__(self, currentLevel, screenSize, debugOn, musicOn, inventory, menuText=[], textColors=[pygame.Color('Salmon'),pygame.Color('Red')], textPos=[0,0], backgroundImageName='screen_title.jpg'):
		myLevels.Title.__init__(self, currentLevel, screenSize, debugOn, musicOn, inventory, menuText, textColors, textPos, backgroundImageName)

				
class Credits(myLevels.Credits):
	def __init__(self, currentLevel, screenSize, debugOn, musicOn, inventory, textColors=[pygame.Color('Salmon'),pygame.Color('Red')], backgroundImageName='screen_credits.png', sortedLayers=[]):
		myLevels.Credits.__init__(self, currentLevel, screenSize, animations, debugOn, musicOn, inventory, textColors, backgroundImageName, sortedLayers)
		
	def checkKeyPressure(self,keyEvent):
		if keyEvent.type == KEYDOWN:
			self.jumpToLevel(TITLESCREEN)
			return True


				