'''Frame management
'''
import os
allFramesDetails={}
allFramesLoaded={}
	
def getImageRowCol(imageName):
	return allFramesDetails[imageName]['row,col']

def getImageFramesNumbers(imageName, action='default'):
	return allFramesDetails[imageName][action]

def getImageActionsNames(imageName):
	actions=allFramesDetails[imageName].keys()
	actions.remove('row,col')
	return actions

def getImagesNames():
	return allFramesDetails.keys()

def getImageFrames(imageName):
	try:
		return allFramesLoaded[imageName]
	except KeyError:
		return allFramesLoaded['miss_image.png']
	
def getImageFramesForAction(imageName, action='default'):
	try:
		return allFramesLoaded[imageName][action]
	except KeyError:
		return allFramesLoaded['miss_image.png']['default']
		

'''for every image specify the name, total frames per row and column, and the frames belonging to every action, as in the sample:

imageName='sample.png'
allFramesDetails[imageName]={}
allFramesDetails[imageName]['row,col']=[8,6] #8 frames in a Row, 6 frames in a Column
allFramesDetails[imageName]['default']=[1]
allFramesDetails[imageName]['stop']=[1]
allFramesDetails[imageName]['win']=[1,2,3]
allFramesDetails[imageName]['lose']=[1,4,5]
allFramesDetails[imageName]['walk']=[6,7,8]
allFramesDetails[imageName]['fight_defense']=[15,16,15]
allFramesDetails[imageName]['fight_attack_hit']=[15,17,18,17,15]
allFramesDetails[imageName]['fight_attack_fail']=[15,17,19,17,15]
allFramesDetails[imageName]['fight_hit']=[15,20,15]
etc etc...
'''

def loadAllFramesDetails():
	imageName='miss_image.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[1,1]
	allFramesDetails[imageName]['default']=[1]

	imageName='obj_ferry.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[4,8]
	allFramesDetails[imageName]['default']=[1]
	allFramesDetails[imageName]['right']=range(1,5)
	allFramesDetails[imageName]['up-right']=range(5,9)
	allFramesDetails[imageName]['up']=range(9,13)
	allFramesDetails[imageName]['up-left']=range(13,17)
	allFramesDetails[imageName]['left']=range(17,21)
	allFramesDetails[imageName]['down-left']=range(21,25)
	allFramesDetails[imageName]['down']=range(25,29)
	allFramesDetails[imageName]['down-right']=range(29,33)

	imageName='obj_river_flow.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[6,4]
	allFramesDetails[imageName]['default']=[1]
	allFramesDetails[imageName][0]=range(1,7)
	allFramesDetails[imageName][4]=range(7,13)
	allFramesDetails[imageName][2]=range(13,19)
	allFramesDetails[imageName][6]=range(19,25)
	
	imageName='obj_river_dock_start.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[4,1]
	allFramesDetails[imageName]['default']=[1,2,3]
	allFramesDetails[imageName]['empty']=[4]
	
	imageName='obj_river_dock_finish.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[3,1]
	allFramesDetails[imageName]['default']=[1,2,3]

	imageName='obj_river_soul.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[1,1]
	allFramesDetails[imageName]['default']=[1]	

	imageName='obj_river_rock.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[4,1]
	allFramesDetails[imageName]['default']=[1]
	allFramesDetails[imageName]['1']=[1]
	allFramesDetails[imageName]['2']=[2]
	allFramesDetails[imageName]['3']=[3]
	allFramesDetails[imageName]['4']=[4]

	
	for imageName in ['obj_river_vortex.png','obj_river_gold.png','obj_river_question.png']:
		allFramesDetails[imageName]={}
		allFramesDetails[imageName]['row,col']=[3,1]
		allFramesDetails[imageName]['default']=[1,2,3]		

	imageName='obj_bridge.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[1,1]
	allFramesDetails[imageName]['default']=[1]


	
	for imageName in ['obj_skeleton.png','obj_ghost.png','obj_fire.png','obj_mysterious.png','obj_warrior.png','obj_damned.png']:
		allFramesDetails[imageName]={}
		allFramesDetails[imageName]['row,col']=[8,1]
		allFramesDetails[imageName]['default']=[1]	
		allFramesDetails[imageName]['[0, -1]']=[1,2]
		allFramesDetails[imageName]['[0, 1]']=[3,4]
		allFramesDetails[imageName]['[-1, 0]']=[5,6]	
		allFramesDetails[imageName]['[1, 0]']=[7,8]

	
	
	imageName='obj_mouse_oar.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[2,1]
	allFramesDetails[imageName]['default']=[1]	
	allFramesDetails[imageName]['click']=[2]	
	
	imageName='obj_lev_miniature.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[4,1]
	allFramesDetails[imageName]['default']=[1]	
	allFramesDetails[imageName]['locked']=[2]	
	allFramesDetails[imageName]['completed_silver']=[3]	
	allFramesDetails[imageName]['completed_gold']=[4]
	
	